function SceneEnterPromoCode(options)
{
	this.options = options;
    this.selfState = new Object();
    this.mode = "";
}

SceneEnterPromoCode.prototype.initialize = function ()
{
	alert("SceneEnterPromoCode.initialize()");
};

SceneEnterPromoCode.prototype.helpBar = function ()
{
    var helpbar = new Object();
    
	if ($("#enterPromoCodeWrapperControls:visible").length == 1)
	{
		helpbar["enter"] = "Wpisz kod";
	}
    
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
    	helpbar["return"] = "Wróć";
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
};

SceneEnterPromoCode.prototype.toogleLoading = function (loading_on)
{
	if (loading_on)
	{
		$("#enterPromoCodeWrapperControls").hide();
		$("#enterPromoCodeWrapperLeft .loadingImage").show();
	}
	else
	{
		$("#enterPromoCodeWrapperLeft .loadingImage").hide();
		$("#enterPromoCodeWrapperControls").show();
	}
};

SceneEnterPromoCode.prototype.handleShow = function ()
{
	alert("SceneEnterPromoCode.handleShow()");
	
	var caller = this;
	this.toogleLoading(false);
	$("#enterPromoCodeInputText").val("");

	
	if (this.mode == "PLUS")
	{
		$("#enterPromoCodeMode").html("PLUS");
	}
	else if (this.mode == "ZERO")
	{
		$("#enterPromoCodeMode").html("ZERO");
	}
	
    var handleKeyDown = function (keyCode)
    {
    	switch (keyCode)
        {
            case $.sfKey.RETURN:
            	$.sfKey.block();
            	$("#enterPromoCodeInputText").blur();
            	$.sf.returnFocus();
            	return false;
                break;
            case $.sfKey.EXIT:
            	$.sfKey.block();
            	$.sf.exit (true);
            	return false;
                break;
    	}
    	
    };
    
    var formCompleted = function (code)
    {
    	$("#enterPromoCodeInputText").blur();
    	$.sf.returnFocus();
    	
    	caller.toogleLoading(true);
    	caller.helpBar();
    	
    	var data = {"coupon_type": caller.mode, "coupon_code": code};
    	var buySubscriptionXHR =  $.sfScene.get("Main").getXHRObj("buySubscription");
    	buySubscriptionXHR.sendXHRRequest(conf.buySubscriptionUrl, function (result, respObj)
        {
            if (result)
            {
            	var obj = $.parseJSON(respObj.responseText);
            	
                if (obj.ERROR_CODE == "OK")
                {
                	$.sfScene.get("Main").getAccountData(function(status)
                	{
                		alert(status);
                		caller.helpBar();
                	}, false);
                	
                	$("#enterPromoCodeInputText").val("");
                	$.sfScene.get("Main").showError("EnterPromoCode", "Twoje konto zostało doładowane.");
                }
                else
                {
                	var msg = "";
                	
                	switch (obj.ERROR_CODE)
                    {
                		case "INVALID_SUBSCRIPTION_TYPE":
                		case "INVALID_SUBSCRIPTION":
                			msg = "Ten kod nie służy do aktywacji wybranego pakietu [6x1].";
                			break;
                			
                		case "INVALID":
                			msg = "Wprowadzony kod jest nieprawidłowy [6x2].";
                			break;

                		case "USED":
                			msg = "Wprowadzony kod został już użyty [6x3].";
                			break;
                			
                		case "INACTIVE":
                			msg = "Wprowadzony kod nie jest przeznaczony do użytku [6x4].";
                			break;
                			
                		case "EXPIRED":
                			msg = "Ważność wprowadzonego kodu wygasła [6x5].";
                			break;
                		default:
                			msg = "Wystapił nieznany błąd [6x6].";
                			break;
                	}
                	
            		$.sfScene.get("Main").showError("EnterPromoCode", msg);
                }
            }
            else
            {
                $.sfScene.get("Main").showError("EnterPromoCode", "Przepraszamy, wystąpił błąd z połączeniem [6x0].<br />Prosimy spróbować ponownie za chwilę.");
            }
        }, $.sfScene.get("Main").getUser().uuid, data);
    	
    	return true;
    };
	
	var imeReady = function (imeObject)
    {
    	imeObject.setKeypadPos(420, 90);
    	//imeObject.setQWERTYPos(400, 70);
    	imeObject.setEnterFunc(formCompleted);
    	imeObject.setBlockSpace(true);
    	imeObject.setKeyFunc($.sfKey.RETURN, handleKeyDown);
    	imeObject.setKeyFunc($.sfKey.EXIT, handleKeyDown);
    	
        $("#enterPromoCodeInputText").focus();
    };
    
	var imeBox = new IMEShell("enterPromoCodeInputText", imeReady);
};

SceneEnterPromoCode.prototype.handleHide = function ()
{
	alert("SceneEnterPromoCode.handleHide()");
	
	$("#enterPromoCodeMode").html("");
};

SceneEnterPromoCode.prototype.handleFocus = function ()
{
	alert("SceneEnterPromoCode.handleFocus()");
	
	this.toogleLoading(false);
    this.helpBar();
};

SceneEnterPromoCode.prototype.handleBlur = function ()
{
	alert("SceneEnterPromoCode.handleBlur()");
};

SceneEnterPromoCode.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneEnterPromoCode.handleKeyDown(" + keyCode + ")");
	
	switch (keyCode)
    {
		case $.sfKey.ENTER:
			if ($("#enterPromoCodeWrapperControls:visible").length == 1)
			{
				$("#enterPromoCodeInputText").focus();
			}
			break;
			
        case $.sfKey.RETURN:
        	$.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
};
