function SceneError(options)
{
	this.options = options;
	this.isShown = false;
}

SceneError.prototype.initialize = function ()
{
	alert("SceneError.initialize()");
};

SceneError.prototype.popupCallback = function (calledByKeyCode)
{
    alert("SceneError.popupCallback(), calledByKeyCode=" + calledByKeyCode);
    
    $.sfScene.hide("Error");
    
    var caller = $.sfScene.get("Error").options.caller;
    var options = $.sfScene.get("Error").options;
    
    if (options.buttons && options.buttons.login && calledByKeyCode == $.sfKey.ENTER)
    {
    	var newScene = {url: "appl://login", caption: "Zaloguj", type: "account_mngmt"};
    	
    	switch (caller)
        {
            case "NavigationMenuCategories":
            case "NavigationMenuMovies":
            case "Login":
            case "EnterPromoCode":
            case "Player":
            case "MoviesPanel":
            	$.sfScene.get("Main").sendRequestForData(newScene, $.sfScene.get(caller).selfState);
                break;
            
            case "Movie":
            	$.sfScene.get("Main").sendRequestForData(newScene, $.sfScene.get("NavigationMenuMovies").selfState);
            	break;
            
            case "AuthenticateUser":
            case "GetAccountData":
            default:
            	$.sfScene.get("Main").sendRequestForData(newScene);
                break;
    	}
    }
    else // NO buttons or Cancel popup
    {
    	switch (caller)
        {
            case "NavigationMenuCategories":
                $.sfScene.focus("NavigationMenuCategories");
                $("#menuCategoriesListbox .loadingImage").remove();
                break;
                
            case "NavigationMenuMovies":
                $.sfScene.focus("NavigationMenuMovies");
                $("#menuMoviesListbox .loadingImage").remove();
                $("#movieLoading").hide();
                break;
                
            case "Player":
                $.sfScene.focus("Player");
                $.sfScene.get("Main").goBack();
                break;
                
            case "Movie":
                $.sfScene.focus("NavigationMenuMovies");
                $("#movieLoading").hide();
                break;
                
            case "MoviesPanel":
                $.sfScene.focus("NavigationMenuCategories");
                $("#moviesPanel").empty();
                break;
                
            case "AuthenticateUser":
                $.sfScene.focus("NavigationMenuCategories");
                break;

            case "GetAccountData":
                $.sfScene.focus("NavigationMenuCategories");
                break;
                
            case "EnterPromoCode":
                $.sfScene.focus("EnterPromoCode");
                break;
                
            case "Login":
                $.sfScene.focus("Login");
                break;
                
            default:
                $.sfScene.focus("Main");
                $("#mainLoading").empty();
                break;
    	}
    }
};

SceneError.prototype.handleShow = function ()
{
	alert("SceneError.handleShow()");
	this.isShown = true;
	
	if (this.options.buttons)
	{
		if (this.options.buttons.login)
		{
			$("#popup #btnLogin").show().css("display", "inline-block");	
		}
		
		if (this.options.buttons.cancel || this.options.buttons.cancelAndReturn)
		{
			$("#popup #btnCancel").show().css("display", "inline-block");
		}
	}
	else
	{
		$("#popup #btnOK").show().css("display", "inline-block");
	}
};

SceneError.prototype.handleHide = function ()
{
	alert("SceneError.handleHide()");
	
	clearTimeout(this.options.hideTimeout);
	$("#popup .message").html("");
	$("#popup .btn").hide();
	$("#popup").hide();
	this.isShown = false;
};

SceneError.prototype.handleFocus = function ()
{
	alert("SceneError.handleFocus()");
    
	var caller = this;
	
	$("#popup").show();
	
    if (typeof this.options.popupMsg == "undefined" || this.options.popupMsg == "")
    {
        $("#popup .message").html("Wystąpił nieznany błąd.");
    }
    else
    {
        $("#popup .message").html(this.options.popupMsg);
    }
    
    if (this.options.buttons && (this.options.buttons.cancel || this.options.buttons.cancelAndReturn))
    {
    	this.options.hideTimeout = setTimeout(function(){ caller.handleKeyDown($.sfKey.RETURN); }, 15000);
    }
    else
    {
    	this.options.hideTimeout = setTimeout(function(){ caller.handleKeyDown($.sfKey.ENTER); }, 10000);
    }
    
};

SceneError.prototype.handleBlur = function ()
{
	alert("SceneError.handleBlur()");
};

SceneError.prototype.preventDefaultBtnBehaviour = function ()
{
	try
	{
		$.sfKey.block();
	}
	catch (e)
	{
		alert(e);
	}
};

SceneError.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneError.handleKeyDown(" + keyCode + ")");
	
	switch (keyCode)
    {
        case $.sfKey.RETURN:
        	this.preventDefaultBtnBehaviour();
        	
        	if (this.options.buttons && this.options.buttons.cancel)
        	{
        		$.sfScene.get("Error").popupCallback(keyCode);
        	}
        	else if (this.options.buttons && this.options.buttons.cancelAndReturn)
        	{
                $.sfScene.hide("Error");
                $.sfScene.get("Main").goBack();
        	}
        	else
        	{
                $.sfScene.hide("Error");
                $.sfScene.get("Main").goBack();
        	}
            break;
        
        case $.sfKey.ENTER:
        	$.sfScene.get("Error").popupCallback(keyCode);
        	break;
	}
};
