function SceneLogin(options)
{
	this.options = options;
    this.selfState = new Object();
}

SceneLogin.prototype.initialize = function ()
{
	alert("SceneLogin.initialize()");
	
	$("#loginRememberMeInputText").sfCheckBox("check");
};

SceneLogin.prototype.helpBar = function ()
{
    var helpbar = new Object();
    
    helpbar["updown"] = "Wybierz pole";
    helpbar["enter"] = "Wprowadź dane";
    
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
    	helpbar["return"] = "Wróć";
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
};

SceneLogin.prototype.toogleLoading = function (loading_on)
{
	if (loading_on)
	{
		$("#loginControls").hide();
		$("#loginWrapperLeft .loadingImage").show();
	}
	else
	{
		$("#loginWrapperLeft .loadingImage").hide();
		$("#loginControls").show();
	}
};

SceneLogin.prototype.formCompleted = function ()
{
	$.sf.returnFocus();
	this.toogleLoading(true);
	var caller = this;
	
	var onLogin = function (status, response)
	{
		switch (status)
		{
			case "TRUE":
				$.sfScene.get("Main").user.nick = response.nick;
				$.sfScene.get("Main").user.uuid = response.uuid;
				$.sfScene.get("Main").user.iplex_plus = null;
				$.sfScene.get("Main").user.iplex_zero = null;
				$.sfScene.get("Main").getAccountData(function(){ $.sfScene.get("Main").goBack(); }, true);
				break;
				
			case "ERROR":
				$.sfScene.get("Main").showError("Login", "Przepraszamy, wystąpił błąd przy logowaniu użytkownika [7x1].<br />Prosimy spróbować ponownie za chwilę.");
				break;
				
			case "INVALID_CREDENTIALS":
				$.sfScene.get("Main").showError("Login", "Podany login lub hasło są niepoprawne. [7x2]");
				break;
				
			default:
				break;
		}
		
		return true;
	};
	
	IplexAuth.login($("#loginLoginInputText").val(), $("#loginPasswordInputText").val(), onLogin, $("#loginRememberMeInputText div").hasClass("sf-ui-icon-checkbox-check"));
	
	return true;
};

SceneLogin.prototype.handleShow = function ()
{
	alert("SceneLogin.handleShow()");
	
	var caller = this;
	this.toogleLoading(false);
	$("#loginLoginInputText").val("");
	$("#loginPasswordInputText").val("");
	
    var handleKeyDown = function (keyCode)
    {
    	switch (keyCode)
        {
            case $.sfKey.RETURN:
            	$.sfKey.block();
            	$("#enterPromoCodeInputText").blur();
            	$.sf.returnFocus();
            	return false;
                break;
            case $.sfKey.UP:
            case $.sfKey.DOWN:
            	$("#enterPromoCodeInputText").blur();
            	$.sf.returnFocus();
                $.sfScene.get("Login").handleKeyDown(keyCode);
                return false;
                break;
            case $.sfKey.EXIT:
            	$.sfKey.block();
            	$.sf.exit (true);
            	return false;
                break;
    	}
    };
    
    var formCompletedLogin = function (login)
    {
    	$("#loginLoginInputText").blur();
		$("#loginControls .loginInput").removeClass("focus");
		$("#loginPasswordInputText").focus().addClass("focus");
    };
    
    var formCompletedPassword = function (password)
    {
    	$("#loginPasswordInputText").blur();
    	caller.formCompleted();
    };    
    
	var imeReady = function (imeObject)
    {
    	imeObject.setKeypadPos(420, 90);
    	
//    	try
//    	{
//    		imeObject.setQWERTYPos(400, 70);	
//    	}
//    	catch (e)
//    	{
//    		alert(e);
//    	}
    	
    	imeObject.setBlockSpace(true);
    	imeObject.setKeyFunc($.sfKey.RETURN, handleKeyDown);
    	imeObject.setKeyFunc($.sfKey.UP, handleKeyDown);
    	imeObject.setKeyFunc($.sfKey.DOWN, handleKeyDown);
    	imeObject.setKeyFunc($.sfKey.EXIT, handleKeyDown);
    };
    
	var imeReadyLogin = function (imeObject)
    {
		imeReady(imeObject);
		imeObject.setEnterFunc(formCompletedLogin);
		$("#loginControls .loginInput").removeClass("focus");
		$("#loginLoginInputText").focus().addClass("focus");
		
		//imeObject.setString("test02@iplex.pl");
    };
    
	var imeReadyPassword = function (imeObject)
    {
		imeReady(imeObject);
		imeObject.setEnterFunc(formCompletedPassword);
		
		//imeObject.setString("test02IPLEX");
    };
    
	var imeBoxLogin = new IMEShell("loginLoginInputText", imeReadyLogin, "pl");
	var imeBoxPassword = new IMEShell("loginPasswordInputText", imeReadyPassword, "pl");
};

SceneLogin.prototype.handleHide = function ()
{
	alert("SceneLogin.handleHide()");
	$("#loginControls .loginInput").removeClass("focus");
};

SceneLogin.prototype.handleFocus = function ()
{
	alert("SceneLogin.handleFocus()");
	
    this.helpBar();
    this.toogleLoading(false);
};

SceneLogin.prototype.handleBlur = function ()
{
	alert("SceneLogin.handleBlur()");
};

SceneLogin.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneLogin.handleKeyDown(" + keyCode + ")");
	
	var moveFocus = function (element, element2)
	{
		var temp = (element.length > 0) ? element : element2;
		
		if (temp.attr("tagName").toLowerCase() == "input")
		{
			temp.focus().addClass("focus");
		}
		else
		{
			temp.addClass("focus");
		}
	};
	
	switch (keyCode)
    {
		case $.sfKey.ENTER:
			var focus_el = $("#loginControls .loginInput.focus");
			
			if ($("#loginRememberMeInputText", focus_el).length > 0)
			{
				if ($("#loginRememberMeInputText div").hasClass("sf-ui-icon-checkbox-check"))
				{
					$("#loginRememberMeInputText").sfCheckBox("uncheck");
				}
				else
				{
					$("#loginRememberMeInputText").sfCheckBox("check");
				}
			}
			else if ($("#loginSubmit", focus_el).length > 0)
			{
				this.formCompleted();
			}
			else
			{
				focus_el.focus();
			}
			break;
			
		case $.sfKey.UP:
			var prev = $("#loginControls .loginInput.focus").removeClass("focus").prevAll(".loginInput").first();
			moveFocus(prev, $("#loginControls .loginInput").last());
			break;
			
		case $.sfKey.DOWN:
			var next = $("#loginControls .loginInput.focus").removeClass("focus").nextAll(".loginInput").first();
			moveFocus(next, $("#loginControls .loginInput").first());
			break;
			
        case $.sfKey.RETURN:
        	$.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}

};
