function SceneMoviesPanel(options)
{
	this.options = options;
	this.panel_initialized = false;
}

SceneMoviesPanel.prototype.initialize = function ()
{
	alert("SceneMoviesPanel.initialize()");
    
    var caller = this;
    
    panelXHR =  $.sfScene.get("Main").getXHRObj("MoviesPanel");
    panelXHR.sendXHRRequest(conf.moviesPanelUrl, function (result, respObj)
    {
        if (result)
        {
        	caller.buildList($.parseJSON(respObj.responseText));
        	caller.panel_initialized = true;
        	
            return true;
        }
        else
        {
            $.sfScene.get("Main").showError("MoviesPanel", "Przepraszamy, wystąpił błąd z połączeniem [2x0].<br />Prosimy spróbować ponownie za chwilę.");
            return false;
        }
    }, $.sfScene.get("Main").getUser().uuid);
};

SceneMoviesPanel.prototype.buildList = function (obj)
{
    $("#moviesPanel").moviesPanel(
    {
        data: obj,
        getElementContentCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("getElementContentCallback: Object expected");
                return "";
            }
            
            var content = "";
            content += "<img src='"+obj.img+"' />";
            content += "<span>"+obj.title+"</span>";
                
            return content;
        },
        clickElementCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("clickElementCallback: Object expected");
                return false;
            }
            
            var newScene = new Object();
            newScene.url = obj.url;
            newScene.caption = "Premiery iplex.pl";
            newScene.type = "playlist";
            newScene.cursor = $("#moviesPanel").moviesPanel("getIndex");
            
            return $.sfScene.get("Main").sendRequestForData(newScene, $.sfScene.get("NavigationMenuCategories").selfState);
        }
    });
    
    return true;
};

SceneMoviesPanel.prototype.helpBar = function ()
{
    var helpbar = new Object();

    if ($("#moviesPanel").mvGetLengthData() != 0)
    {
        helpbar["move"] = "Wybierz film";
        helpbar["enter"] = "Zatwierdź wybór";
    }
    
    helpbar["leftright"] = "Przejdź do kategorii";
        
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
    	helpbar["return"] = "Wróć";
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
};

SceneMoviesPanel.prototype.handleShow = function ()
{
	alert("SceneMoviesPanel.handleShow()");
	
	if (!this.panel_initialized)
	{
		this.initialize();
	}
};

SceneMoviesPanel.prototype.handleHide = function ()
{
	alert("SceneMoviesPanel.handleHide()");
};

SceneMoviesPanel.prototype.handleFocus = function ()
{
	alert("SceneMoviesPanel.handleFocus()");
    
    $("#moviesPanel").moviesPanel("focus");
    this.helpBar();
};

SceneMoviesPanel.prototype.handleBlur = function ()
{
	alert("SceneMoviesPanel.handleBlur()");
    $("#moviesPanel").moviesPanel("blur");
};

SceneMoviesPanel.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneMoviesPanel.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
        case $.sfKey.LEFT:
            if (!$("#moviesPanel").moviesPanel("left"))
            {
                $.sfScene.focus("NavigationMenuCategories");
            }
            break;
		case $.sfKey.RIGHT:
            $("#moviesPanel").moviesPanel("right");
			break;
		case $.sfKey.UP:
            $("#moviesPanel").moviesPanel("up");
			break;
		case $.sfKey.DOWN:
            $("#moviesPanel").moviesPanel("down");
            break;
            
		case $.sfKey.ENTER:
		    if (internetConnectionCheck.connectionAvailable() && internetConnectionCheck.checkInterfaces())
		    {
		    	$("#moviesPanel").moviesPanel("click");
		    }
			break;
            
        case $.sfKey.RETURN:
            $.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
};
