function SceneNavigationMenuCategories(options)
{
	this.options = options;
    this.selfState = new Object();
}

SceneNavigationMenuCategories.prototype.initialize = function ()
{
	alert("SceneNavigationMenuCategories.initialize()");
};

SceneNavigationMenuCategories.prototype.buildListCategory = function (obj)
{
    var caller = this;
    
    if (obj.type != "category")
    {
        $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd serwera [1x2].");
        return false;
    }
    
    this.selfState.caption = obj.caption;
    
    $("#menuCategoriesLabel").html(obj.caption);
    
    if (obj.feeds.length == 0)
    {
        $.sfScene.get("Main").showError("NavigationMenuCategories", "Lista kategorii jest pusta [1x3].");
    }
    
    $("#menuCategoriesListbox").sfListbox2(
    {
        data: obj.feeds,
        itemsPerPage: 9,
        index: this.selfState.cursor,
        getElementContentCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("getElementContentCallback: Object expected");
                return "";
            }
            
            return obj.caption;
        },
        clickElementCallback: function(obj)
        {
            if (typeof obj != "object" || obj.url == null)
            {
                alert("clickElementCallback: Object expected");
                return false;
            }
            
            var newScene = new Object();
            newScene.url = obj.url;
            newScene.caption = obj.caption;
            newScene.type = obj.type;
            newScene.cursor = 0;
            
            return $.sfScene.get("Main").sendRequestForData(newScene, caller.selfState);
        }
    });
    
    this.helpBar();
    
    return true;
};

SceneNavigationMenuCategories.prototype.buildListAccount = function (obj)
{
    var caller = this;
    
    if (obj.type != "account")
    {
        $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd serwera [1x4].");
        return false;
    }
    
    this.selfState.caption = obj.caption;
    
    $("#menuCategoriesLabel").addClass("account_list").html(obj.caption + "<br /><span>(" + $.sfScene.get("Main").getUser().nick + ")</span>");
    
    obj.feeds.push({url: "appl://enter_promo_code_plus", caption: "Wpisz kod promocyjny IPLEX PLUS", type: "account_mngmt"});
    obj.feeds.push({url: "appl://enter_promo_code_zero", caption: "Wpisz kod promocyjny IPLEX ZERO", type: "account_mngmt"});
    obj.feeds.push({url: "appl://logout", caption: "Wyloguj", type: "account_mngmt"});
    
    $("#menuCategoriesListbox").sfListbox2(
    {
        data: obj.feeds,
        itemsPerPage: 9,
        index: this.selfState.cursor,
        getElementContentCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("getElementContentCallback: Object expected");
                return "";
            }
            
            return obj.caption;
        },
        clickElementCallback: function(obj)
        {
            if (typeof obj != "object" || obj.url == null)
            {
                alert("clickElementCallback: Object expected");
                return false;
            }
            
            var newScene = new Object();
            newScene.url = obj.url;
            newScene.caption = obj.caption;
            newScene.type = obj.type;
            newScene.cursor = 0;
            
            return $.sfScene.get("Main").sendRequestForData(newScene, caller.selfState);
        }
    }).addClass("account_list");
    
    this.helpBar();
    
    return true;
};

SceneNavigationMenuCategories.prototype.sendRequestForData = function (obj)
{
    if (typeof obj != "object" || obj.url == null)
    {
        alert("SceneNavigationMenuCategories: Object expected");
        return false;
    }
    
    $("#menuCategoriesLabel").removeClass("account_list");
    $("#menuCategoriesListbox").sfListbox2("clear").removeClass("account_list").html('<img src="images/loading.gif" class="loadingImage" />');
    
    this.selfState = obj;
    var caller = this;
    
    menuXHR =  $.sfScene.get("Main").getXHRObj("NavigationMenuCategories");
    menuXHR.sendXHRRequest(this.selfState.url, function (result, respObj)
    {
        if (result)
        {
        	var obj = $.parseJSON(respObj.responseText);
        	
            if (obj.ERROR_CODE == "NOT_AUTHENTICATED")
            {
            	$.sfScene.get("Main").logoutUser();
                $.sfScene.get("Main").showError("NavigationMenuCategories", "Aby skorzystać z tej funkcji musisz się zalogować. Czy chcesz się teraz zalogować? [1x5].", {"login": true, "cancelAndReturn": true});
                return false;
            }
        	
        	if (obj.type == "category")
        	{
        		caller.buildListCategory(obj);
        	}
        	else if (obj.type == "account")
        	{
        		caller.buildListAccount(obj);
        	}
        	else
        	{
                $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd serwera [1x1].");
                return false;
        	}
        	
            return true;
        }
        else
        {
            $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd z połączeniem [1x0].<br />Prosimy spróbować ponownie za chwilę.");
            return false;
        }
    }, $.sfScene.get("Main").getUser().uuid);
};

SceneNavigationMenuCategories.prototype.helpBar = function ()
{
    var helpbar = new Object();
    
    if ($("#menuCategoriesListbox").getLengthData() != 0)
    {
        helpbar["updown"] = "Wybierz kategorię";
        helpbar["enter"] = "Zatwierdź wybór";
    }
    
    helpbar["leftright"] = "Przejdź do premier";
    
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
    	helpbar["return"] = "Wróć";
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
};

SceneNavigationMenuCategories.prototype.focusListElement = function (position)
{
    $("#menuCategoriesListbox").sfListbox2("setPosition", position);
    this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");
    $("#menuCategoriesListbox").sfListbox2("focus");
};

SceneNavigationMenuCategories.prototype.handleShow = function ()
{
	alert("SceneNavigationMenuCategories.handleShow()");
};

SceneNavigationMenuCategories.prototype.handleHide = function ()
{
	alert("SceneNavigationMenuCategories.handleHide()");
	
	$("#menuCategoriesLabel").removeClass("account_list");
    $("#menuCategoriesListbox").sfListbox2("clear").removeClass("account_list");
    $.sfScene.get("Main").getXHRObj("NavigationMenuCategories").abortXHRObj();
};

SceneNavigationMenuCategories.prototype.handleFocus = function ()
{
	alert("SceneNavigationMenuCategories.handleFocus()");
	
    $("#menuCategoriesListbox").sfListbox2("focus");
    this.helpBar();
};

SceneNavigationMenuCategories.prototype.handleBlur = function ()
{
	alert("SceneNavigationMenuCategories.handleBlur()");
	$("#menuCategoriesListbox").sfListbox2("blur");
};

SceneNavigationMenuCategories.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneNavigationMenuCategories.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
		case $.sfKey.RIGHT:
            $.sfScene.focus("MoviesPanel");
			break;
            
            
		case $.sfKey.UP:
			if ($("#menuCategoriesListbox").getLengthData())
			{
	            $("#menuCategoriesListbox").sfListbox2("prev");
	            this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");				
			}
			break;
            
		case $.sfKey.DOWN:
			if ($("#menuCategoriesListbox").getLengthData())
			{
	            $("#menuCategoriesListbox").sfListbox2("next");
	            this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");				
			}
            break;
            
        
		case $.sfKey.ENTER:
			if ($("#menuCategoriesListbox").getLengthData() && internetConnectionCheck.connectionAvailable() && internetConnectionCheck.checkInterfaces())
			{
				$("#menuCategoriesListbox").sfListbox2("click");	
			}
			break;
            
            
        case $.sfKey.RETURN:
            $.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
};
