function SceneNavigationMenuMovies(options)
{
	this.options = options;
    this.selfState = new Object();
    this.refreshMovieSceneTimer = null;
}

SceneNavigationMenuMovies.prototype.initialize = function ()
{
	alert("SceneNavigationMenuMovies.initialize()");
};

SceneNavigationMenuMovies.prototype.buildList = function (obj)
{
    if (obj.ERROR_CODE == "NOT_AUTHENTICATED")
    {
    	$.sfScene.get("Main").logoutUser();
        $.sfScene.get("Main").showError("NavigationMenuMovies", "Aby skorzystać z tej funkcji musisz się zalogować. Czy chcesz się teraz zalogować? [3x3].", {"login": true, "cancelAndReturn": true});
        return false;
    }
	
	if (obj.type != "playlist")
    {
        $.sfScene.get("Main").showError("NavigationMenuMovies", "Przepraszamy, wystąpił błąd serwera [3x1].");
        return false;
    }
    
    var caller = this;
    
    this.selfState.caption = obj.caption;
    
    $("#movieDescLabel").html(obj.caption);
    
    if (obj.feeds.length == 0)
    {
        $.sfScene.get("Main").showError("NavigationMenuMovies", "Lista filmów jest pusta [3x2].");
    }
    
    $("#menuMoviesListbox").sfListbox2(
    {
        data: obj.feeds,
        itemsPerPage: 5,
        index: this.selfState.cursor,
        getElementContentCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("getElementContentCallback: Object expected");
                return "";
            }
            
            var content = "";
            content += "<img src='"+obj.img+"' />";
            if (obj.license == "PAID")
            {
            	content += "<img class='iplex_plus' src='images/iplex_plus_logo_small.png' />";	
            }
            content += "<div class='wrapper'>";
            content += "<div class='title'>"+obj.title+"</div>";
            content += "<div class='rating'>Ocena: "+obj.rating+"</div>";
            
            if (typeof obj.duration == "number")
            {
                content += "<div class='duration'>Czas trwania: "+obj.duration+" min</div>";
            }
            else if (typeof obj.movies_count == "number")
            {
                content += "<div class='movies_count'>Liczba odcinków: "+obj.movies_count+" odc.</div>";
            }
            
            content += "</div>";
            
            return content;
        },
        clickElementCallback: function(obj)
        {
            if (typeof obj != "object" || obj.url == null)
            {
                alert("clickElementCallback: Object expected");
                return false;
            }
            
            var newScene = new Object();
            newScene.url = obj.url;
            newScene.caption = obj.caption;
            newScene.type = obj.type;
            newScene.cursor = 0;
            
            return $.sfScene.get("Main").sendRequestForData(newScene, caller.selfState);
        }
    });
    
    $.sfScene.get("Main").sendRequestForData($("#menuMoviesListbox").sfListbox2("getCurrentElement"));
    
    return true;
};

SceneNavigationMenuMovies.prototype.sendRequestForData = function (obj)
{
    if (typeof obj != "object" || obj.url == null)
    {
        alert("SceneNavigationMenuMovies: Object expected");
        return false;
    }
	
    $("#menuMoviesListbox").sfListbox2("clear").html('<img src="images/loading.gif" class="loadingImage" />');
    
    this.selfState = obj;
    var caller = this;
    
    menuXHR =  $.sfScene.get("Main").getXHRObj("NavigationMenuMovies");
    menuXHR.sendXHRRequest(this.selfState.url, function (result, respObj)
    {
        if (result)
        {
        	caller.buildList($.parseJSON(respObj.responseText));
            return true;
        }
        else
        {
            $.sfScene.get("Main").showError("NavigationMenuMovies", "Przepraszamy, wystąpił błąd z połączeniem [3x0].<br />Prosimy spróbować ponownie za chwilę.");
            //return false;
        }
    }, $.sfScene.get("Main").getUser().uuid);
};

SceneNavigationMenuMovies.prototype.helpBar = function ()
{
    var helpbar = new Object();
    
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
    	helpbar["return"] = "Wróć";
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
};

SceneNavigationMenuMovies.prototype.focusListElement = function (position)
{
    clearTimeout(this.refreshMovieSceneTimer);
    $.sfScene.get("Movie").setFocusable(false);
    $.sfScene.get("Movie").resetButtons(false);
    $("#menuMoviesListbox").sfListbox2("setPosition", position);
    this.selfState.cursor = $("#menuMoviesListbox").sfListbox2("getIndex");
    $("#menuMoviesListbox").sfListbox2("focus");
    $.sfScene.get("Main").sendRequestForData($("#menuMoviesListbox").sfListbox2("getCurrentElement"));
};

SceneNavigationMenuMovies.prototype.handleShow = function ()
{
	alert("SceneNavigationMenuMovies.handleShow()");
    
    this.helpBar();
};

SceneNavigationMenuMovies.prototype.handleHide = function ()
{
	alert("SceneNavigationMenuMovies.handleHide()");
    
    $("#menuMoviesListbox").sfListbox2("clear");
    $.sfScene.get("Main").getXHRObj("NavigationMenuMovies").abortXHRObj();
};

SceneNavigationMenuMovies.prototype.handleFocus = function ()
{
	alert("SceneNavigationMenuMovies.handleFocus()");
    
    $("#menuMoviesListbox").sfListbox2("focus");
};

SceneNavigationMenuMovies.prototype.handleBlur = function ()
{
	alert("SceneNavigationMenuMovies.handleBlur()");
    
    $("#menuMoviesListbox").sfListbox2("blur");
};

SceneNavigationMenuMovies.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneNavigationMenuMovies.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
		case $.sfKey.RIGHT:
            if ($.sfScene.get("Movie").getFocusable())
            {
                $.sfScene.focus("Movie");
            }
			break;
            
            
		case $.sfKey.UP:
			if ($("#menuMoviesListbox").getLengthData())
			{
	            clearTimeout(this.refreshMovieSceneTimer);
	            $.sfScene.get("Movie").setFocusable(false);
	            $.sfScene.get("Movie").resetButtons(false);
	            $("#menuMoviesListbox").sfListbox2("prev");
	            if (internetConnectionCheck.connectionAvailable() && internetConnectionCheck.checkInterfaces())
	            {
	            	this.selfState.cursor = $("#menuMoviesListbox").sfListbox2("getIndex");
	            	this.refreshMovieSceneTimer = setTimeout('$.sfScene.get("Main").sendRequestForData($("#menuMoviesListbox").sfListbox2("getCurrentElement"))', conf.refreshMovieSceneTimeout);
	            }
			}
			break;
            
		case $.sfKey.DOWN:
			if ($("#menuMoviesListbox").getLengthData())
			{
	            clearTimeout(this.refreshMovieSceneTimer);
	            $.sfScene.get("Movie").setFocusable(false);
	            $.sfScene.get("Movie").resetButtons(false);
	            $("#menuMoviesListbox").sfListbox2("next");
	            if (internetConnectionCheck.connectionAvailable() && internetConnectionCheck.checkInterfaces())
	            {
	            	this.selfState.cursor = $("#menuMoviesListbox").sfListbox2("getIndex");
	            	this.refreshMovieSceneTimer = setTimeout('$.sfScene.get("Main").sendRequestForData($("#menuMoviesListbox").sfListbox2("getCurrentElement"))', conf.refreshMovieSceneTimeout);
	            }
			}
            break;
            
            
		case $.sfKey.GREEN:
		case $.sfKey.BLUE:
		case $.sfKey.RED:
        case $.sfKey.YELLOW:
        case $.sfKey.ENTER:
        	if ($("#menuMoviesListbox").getLengthData())
        	{
        		$.sfScene.get("Movie").handleKeyDown(keyCode);
        	}
			break;
            
            
        case $.sfKey.RETURN:
            $.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
};
