var XHRToolKit = function () 
{
    var URL = "";
    var sendResultFunc = function(){return true;};
    var XHRObj = null;
    var waitForConnection = null;
    var connectionTimeoutSeconds = 15000;
    var self = this;
    
    this.sendXHRRequest = function(pURL, pSendResultFunc, uuid, data)
    {
    	clearTimeout(waitForConnection);
    	
    	//uuid = "a6650053-50f4-42c7-ba76-339fcc69a299";
    	
        if (typeof pURL != "undefined")
        {
            URL = pURL.appendParam("session_id", uuid).appendParam("iplex_ts", (new Date()).getTime());
        }
        
        //alert("sendXHRRequest(): " + URL);
        //alert("sendXHRRequest() POST: " + this.objectToPostData(data));
        
        if (typeof pSendResultFunc != "undefined")
        {
            sendResultFunc = pSendResultFunc;
        }
        
        this.destroyXHRObj();
        
        XHRObj = new XMLHttpRequest();
        
        if (XHRObj)
        {
            if (XHRObj.overrideMimeType)
            {
            	XHRObj.overrideMimeType('text/xml');
        	}
            
            XHRObj.onreadystatechange = function ()
            {
                if (XHRObj.readyState == 4)
                {
                    receiveXHRResponse();
                }
            };
            
            if (typeof data == "undefined")
            {
                XHRObj.open("GET", URL, true);
                XHRObj.setRequestHeader('Cache-Control', 'no-cache, no-store, must-revalidate'); // HTTP 1.1. 
                XHRObj.setRequestHeader('Pragma', 'no-cache'); // HTTP 1.0. 
                XHRObj.setRequestHeader('Expires', '0'); // Proxies.
                XHRObj.send(null);            	
            }
            else
            {
                XHRObj.open("POST", URL, true);
                XHRObj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
                XHRObj.setRequestHeader('Cache-Control', 'no-cache, no-store, must-revalidate'); // HTTP 1.1. 
                XHRObj.setRequestHeader('Pragma', 'no-cache'); // HTTP 1.0. 
                XHRObj.setRequestHeader('Expires', '0'); // Proxies.
                XHRObj.send(this.objectToPostData(data));
            }
            
            waitForConnection = setTimeout(connectionTimeout, connectionTimeoutSeconds);
        }
        else
        {
            alert("XHR Object is NULL");
        }
    };
    
    var receiveXHRResponse = function ()
    {
    	clearTimeout(waitForConnection);
    	
        if (XHRObj.status == 200)
        {
            sendResultFunc(true, XHRObj);
        }
        else
        {
            sendResultFunc(false, XHRObj);
        }
    };
    
    var connectionTimeout = function ()
    {
    	//alert("Connection Timeout " + URL);
    	
    	self.abortXHRObj();
    	sendResultFunc(false, XHRObj);
    };
    
    this.objectToPostData = function (data)
    {
    	var temp = "";
    	if (data)
    	{
    		$.each(data, function(k, v)
			{
	    		if (temp != "")
	    		{
	    			temp += "&";
	    		}
	    		
				temp += k + "=" + v; 
			});
    	}
    	
    	return temp;
    };

    this.getResponse = function ()
    {
        return XHRObj.responseText;
    };

    this.getXHRObj = function ()
    {
        return XHRObj;
    };

    this.abortXHRObj = function ()
    {
        if (XHRObj)
        {
        	//alert("About to abort " + URL);
            XHRObj.abort();
            //alert("Connection aborted " + URL);
        }
    };
    
    this.destroyXHRObj = function()
    {
        if (XHRObj)
        {
        	//alert("About to destroy " + URL);
        	XHRObj.destroy();
        	XHRObj = null;
        	//alert("Connection destroyed " + URL);
        }
    };
};
