var IplexAuth = {};

IplexAuth.storeCredentials = function (login, password)
{
	// check and create application common dir
	var fileSystemObj = new FileSystem();

	if (fileSystemObj.isValidCommonPath(curWidget.id) != 1)
	{
		fileSystemObj.createCommonDir(curWidget.id);
	}
	
	var fileObj = fileSystemObj.openCommonFile(curWidget.id + "/" + conf.iplexCredentialsFile, "w");
	
	var credentials = '{"login": "'+login+'", "password": "'+password+'"}';
	
	fileObj.writeAll(credentials);
	fileSystemObj.closeCommonFile(fileObj);
	
	return true;
};

IplexAuth.readCredentials = function ()
{
	var credentials = null;
	
	// check and create application common dir
	var fileSystemObj = new FileSystem();

	if (fileSystemObj.isValidCommonPath(curWidget.id) != 1)
	{
		fileSystemObj.createCommonDir(curWidget.id);
	}

	var fileObj = fileSystemObj.openCommonFile(curWidget.id + "/" + conf.iplexCredentialsFile, "r");

	if (fileObj)
	{
		credentials = $.parseJSON(fileObj.readAll());
	    fileSystemObj.closeCommonFile(fileObj);
	    return credentials;
	}
	else
	{
		return false;
	}
};

IplexAuth.deleteCredentials = function ()
{
	// check and create application common dir
	var fileSystemObj = new FileSystem();

	if (fileSystemObj.isValidCommonPath(curWidget.id) != 1)
	{
		return true;
	}
	
	return fileSystemObj.deleteCommonFile(curWidget.id + "/" + conf.iplexCredentialsFile);
};

IplexAuth.autoLogin = function (fnCallback)
{
	//this.storeCredentials("test02@iplex.pl", "test02IPLEX");
	var credentials = this.readCredentials();
	
	if (credentials)
	{
		this.login(credentials.login, credentials.password, fnCallback, false);
	}
	else
	{
		fnCallback("NOUSER");
	}
};

IplexAuth.logout = function ()
{
	this.deleteCredentials();
};

IplexAuth.login = function (login, password, fnCallback, storeCredentials)
{
	var data = "login="+login+"&password="+password;
	var xhttpObject = null;
	var caller = this;
	
	function receivebrowserXHRResponse()
	{
		var response = $.parseJSON(xhttpObject.responseText);
		
		if (typeof response.ERROR_CODE != "undefined" && response.ERROR_CODE == "INVALID_CREDENTIALS")
		{
			fnCallback("INVALID_CREDENTIALS");
		}
		else if (typeof response.ERROR_CODE != "undefined")
		{
			fnCallback("ERROR");
		}
		else if (typeof response.uuid != "undefined")
		{
			if (storeCredentials)
			{
				caller.storeCredentials(login, password);	
			}
			
			fnCallback("TRUE", response);
		}
		else
		{
			fnCallback("ERROR");
		}
	}
	
	if (window.XMLHttpRequest)
	{
		xhttpObject = new XMLHttpRequest();
	}

	if (xhttpObject != null) 
	{
		xhttpObject.onreadystatechange = function () 
		{
			if (xhttpObject.readyState == 4) 
			{
				
		    	if(xhttpObject.status == 0) //abort
		    	{
		    		fnCallback("ERROR");
		        }
		    	
				if (xhttpObject.status == 200)
				{
					receivebrowserXHRResponse();                                  
				}
				else
				{
					fnCallback("ERROR");
				}
			}
		};
		
		xhttpObject.open("POST", conf.authURL, true);
		xhttpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");       
		xhttpObject.send(data);
	}
};
