function InternetConnectionCheck ()
{
	var network_plugin = null;
	var interval = null;
	var error_message_shown = false;
	var attempts_counter = 0;
	var attempts_before_alert = 5;
	var check_url = null;
	var check_url_connection = null;
	var status = "NOT_CONNECTED";
	var self = this;
	
	this.init = function (_time_interval, _attempts_before_alert, _check_url)
	{
		//alert("Initializing connection testing procedure");
		
		network_plugin  = document.getElementById('pluginObjectNetwork');
		error_message_shown = false;
		attempts_before_alert = _attempts_before_alert;
		check_url = _check_url;
		check_url_connection = new XHRToolKit();
		status = "NOT_CONNECTED";
		this.testConnection();
		interval = setInterval(this.testConnection, _time_interval);
	};
	
	this.deinit = function ()
	{
		//alert("Deinitializing connection testing procedure");
		
		error_message_shown = false;
		status = "NOT_CONNECTED";
		clearInterval(interval);
		check_url_connection.abortXHRObj();
		check_url_connection.destroyXHRObj();
		check_url_connection = null;
	};
	
	this.connectionAvailable = function ()
	{
		//alert ("Connection status: " + status);
		
		return (status == "CONNECTED");
	};
	
	this.testConnection = function ()
	{
		//alert("Testing connection: " + attempts_counter + ":" + attempts_before_alert);
		
		if (!self.checkInterfaces())
		{
			status = "NOT_CONNECTED";
			attempts_counter = attempts_counter + 1;
			
			if (!error_message_shown && (attempts_counter > attempts_before_alert))
			{
				try
				{
					$("#videoComponent").sfVideo2("RCKeyDefined", $.sfKey.STOP);	
				}
				catch (e)
				{
					alert(e);
				}
				
				var scene = $.sfScene.get("Main").getCurrentScene();
				var caller = "";
				
			    if (scene.type == "category")
			    {
			    	caller = "NavigationMenuCategories";
			    }
			    else if (scene.type == "playlist")
			    {
			    	caller = "NavigationMenuMovies";
			    }
			    else if (scene.type == "video")
			    {
			    	caller = "Player";
			    }
			    else if (scene.type == "movie_card")
			    {
			    	caller = "NavigationMenuMovies";
			    }
			    else if (scene.type == "series_card")
			    {
			    	caller = "NavigationMenuMovies";
			    }
			    else
			    {
			        alert("testConnection: Unsuported object type="+scene.type+". Using default Main");
			        caller = "Main";
			    }
				
				$.sfScene.get("Main").showError(caller, "Brak połączenia z siecią.");
				error_message_shown = true;
				
			    // abort requests
			    $.each(xhr, function(index, value)
			    {
			        value.abortXHRObj();
			    });
			}
		}
		else
		{
			attempts_counter = 0;
			
			if (status == "NOT_CONNECTED")
			{
				self.checkRealConnection(function(connectionEstablished)
				{
					//alert("Real connection status: " + connectionEstablished);
					
					if (connectionEstablished)
					{
						status = "CONNECTED";
						
						if (error_message_shown)
						{
							error_message_shown = false;
							$.sfScene.hide("Error");
							var scene = $.sfScene.get("Main").getCurrentScene();
							
							if (typeof scene.type == "undefined") //application has been not initialized
							{
								$.sfScene.get("Main").initialize();
							}
							else
							{
								$.sfScene.get("Main").sendRequestForData(scene);
							}
						}
					}
					
				});
			}
		}
	};
	
	this.checkInterfaces = function ()
	{
		//alert("Testing interfaces");
		
        var physicalConnection = 0;
        var httpStatus = 0;

        // Get active connection type - wired or wireless.
        currentInterface = network_plugin.GetActiveType();
        
        // If no active connection.
        if (currentInterface === -1)
        {
        	return false;
        }
        
        // Check physical connection of current interface.
        physicalConnection = network_plugin.CheckPhysicalConnection(currentInterface);
        
        // If not connected or error.
        if (physicalConnection !== 1)
        {
        	return false;
        }
        
        // Check HTTP transport.
        httpStatus = network_plugin.CheckHTTP(currentInterface);
        
        // If HTTP is not available.
        if (httpStatus !== 1)
        {
        	return false;
        }
        
        // Everything went OK.
        return true;
	};
	
	this.checkRealConnection = function (callback)
	{
		//alert("Testing real connection");
		
		check_url_connection.sendXHRRequest(check_url, callback);
	};
}