(function ($)
{
	var stateClasses = "sf-ui-moviespanel-blured sf-ui-moviespanel-focused sf-ui-moviespanel-selected";
	
	$.fn.mvGetLengthData = function()
    {
		return $(this).data("data").length;
	};
    
	$.fn.mvIsFocus = function()
    {
		return $(this).data("focus");
	};
    
	$.fn.moviesPanel = function(options, value)
    {
		//alert("moviesPanel(" + $(this).attr("id") + ", " + options + ")");
		
		if (!($(this).data("sfui") == "sfMoviesPanel"))
        {
			$(this)
				.data("data", [])
				.data("index", 0)
				.data("itemsPerPage", 12)
                .data("itemsPerRow", 4)
				.data("focus", false)
				.data("sfui", "sfMoviesPanel")
                .data("getElementContentCallback", null)
                .data("clickElementCallback", null)
                .addClass("sf-ui-moviespanel");
		}
        
		if (typeof options == "object")
        {
			var defaults =
            {
				data: $(this).data("data"),
				index: $(this).data("index"), 
				itemsPerPage: $(this).data("itemsPerPage"),
                itemsPerRow: $(this).data("itemsPerRow"),
                getElementContentCallback: $(this).data("getElementContentCallback"),
                clickElementCallback: $(this).data("clickElementCallback")
			};
            
			var opts = $.extend(defaults, options);
            
			$(this)
				.html(getDiv(opts.itemsPerPage, opts.itemsPerRow))
				.data("data", opts.data)
				.data("index", opts.index)
				.data("itemsPerPage", opts.itemsPerPage)
                .data("itemsPerRow", opts.itemsPerRow)
                .data("getElementContentCallback", opts.getElementContentCallback)
                .data("clickElementCallback", opts.clickElementCallback);
            
			blur(this);

			if (options.index != undefined)
            {		
				$(this).data("focus", true);
				focus(this, opts.index);
			}
            
			insert(this, opts.index);
		}
        
		if (typeof options == "string")
        {
			switch (options)
            {
				case "left":
				case "right":
				case "up":
                case "down":
					if (!$(this).data("focus"))
                    {
						$(this).moviesPanel("focus");
						$(this).data("focus", true);
						break;
					}
					
					var old_el = Number($(this).data("index"));
                    var new_el = 0;
                    
					var itemsPerPage = $(this).data("itemsPerPage");
                    var itemsPerRow = $(this).data("itemsPerRow");
					var data = $(this).data("data");
					
					if (options == "left")
                    {
                        if (old_el % itemsPerRow == 0 || old_el <= 0) // first element in row or first element
                        {
                            return false;
                        }
                        else
                        {
                            new_el = old_el - 1;
                        }
                    }
                    else if (options == "right")
                    {
                        if ((old_el + 1) % itemsPerRow == 0 || old_el >= data.length - 1 || old_el >= itemsPerPage - 1) // last element in row or last element or max elements on panel
                        {
                            return false;
                        }
                        else
                        {
                            new_el = old_el + 1;
                        }
                    }
                    else if (options == "up")
                    {
                        if (old_el - itemsPerRow < 0)
                        {
                            return false;
                        }
                        else
                        {
                            new_el = old_el - itemsPerRow;
                        }
                    }
                    else if (options == "down")
                    {
                        if (old_el + itemsPerRow > data.length - 1 || old_el + itemsPerRow > itemsPerPage - 1)
                        {
                            return false;
                        }
                        else
                        {
                            new_el = old_el + itemsPerRow;
                        }
                    }
                    
					blur (this, old_el);
					focus (this, new_el);
                    
					$(this).data("index", new_el);
                    
                    return true;
					break;
                    
				case "getIndex":
					return $(this).data("index");
                    
				case "setIndex":
					if (isNaN(value))
                    {
						alert("Cannot set the index. Second parameter must be a number.");
                        break;
					}
                    
                    if ($(this).data("data").length -1 < value )
                    {
						alert("Cannot set the index. Index out of bounds.");
                        break;
                    }
                    
                    $(this).data("index", value);
                    blur(this);
					break;
                    
				case "focus":
					focus(this, $(this).data("index"));
					$(this).data("focus", true);
					break;
                    
				case "blur":
					select(this, $(this).data("index"));
					$(this).data("focus", false);
					break;
                    
				case "clear":
                    $(this)
                        .html("")
                        .data("data", [])
                        .data("index", 0)
                        .data("itemsPerPage", 0)
                        .data("focus", false)
                        .data("getElementContentCallback", null)
                        .data("clickElementCallback", null);
					break;
                    
				case "show":
					$(this).show();
					break;
                    
				case "hide":
					$(this).hide();
					break;
                    
                 case "click":
                    clickElement(this, $(this).data("index"));
                    break;
                    
				default:
					break;
			}
		}
		return this;
	};
	
	function focus (self, index)
    {
		//alert("focus("+self+","+(index?index:"all")+")");
        
		var selecter = (index === undefined) ? "" : ":nth-child("+(index+1)+")";
        
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-moviespanel-focused");
	}
	
	function blur (self, index)
    {
		//alert("blur("+self+","+(index?index:"all")+")");
        
		var selecter = (index === undefined) ? "" : ":nth-child("+(index+1)+")";
		
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-moviespanel-blured");
	}
    
	function select (self, index)
    {
		//alert("select("+self+","+(index?index:"all")+")");
        
		var selecter = (index === undefined) ? "" : ":nth-child("+(index+1)+")";
        
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-moviespanel-selected");
	}
	
	function insert (self, index)
    {
		//alert("insert("+self+","+index+")");
        
		//var itemsPerPage = $(self).data("itemsPerPage");
		var data = $(self).data("data");
        
		$(self).children("div.content").each(function(index, element)
        {
            elementId = Number(element.id);
            
            if (index < data.length)
            {
                if (elementId == index)
                {
                    $(element).html(getElementContent(self, index)).removeClass("sf-ui-moviespanel-empty");
                }
                else
                {
                    if (data[elementId] == undefined)
                    {
                        $(element).html("").addClass("sf-ui-moviespanel-empty");
                    }
                    else
                    {
                        $(element).html(getElementContent(self, elementId)).removeClass("sf-ui-moviespanel-empty");
                    }
                }
            }
            else
            {
                if ( data[elementId] == undefined)
                {
                    $(element).html("").addClass("sf-ui-moviespanel-empty");
                }
                else
                {
                    $(element).html(getElementContent(self, index)).removeClass("sf-ui-moviespanel-empty");
                }
            }
        });
	}
    
    function getElementContent (self, index)
    {
        if ($(self).data("getElementContentCallback"))
        {
            if (index < 0 || index > $(self).data("data").length - 1)
            {
                alert("getElementContent: index out of range");
                return "";
            }
            else
            {
                return $(self).data("getElementContentCallback")($(self).data("data")[index]);
            }
        }
        else
        {
            alert("getElementContentCallback not implemented");
            return "";
        }
    }
    
    function clickElement (self, index)
    {
        if ($(self).data("clickElementCallback"))
        {
            if (index < 0 || index > $(self).data("data").length - 1)
            {
                alert("clickElement: index out of range");
                return false;
            }
            else
            {
                return $(self).data("clickElementCallback")($(self).data("data")[index]);
            }
        }
        else
        {
            alert("clickElementCallback not implemented");
            return false;
        }
    }

	function getDiv (perPage, perRow)
    {
		var retValue = "";
		for (var i=0; i < perPage; i++)
        {
            var cl = "";
            if (i % perRow == 0)
            {
                cl = " first";
            }
            else if ((i + 1) % perRow == 0)
            {
                cl = " last";
            }
            
            retValue += "<div class='content"+cl+"' id='" +  i +"'></div>";
        }
        
		return retValue;
	}
	
})(jQuery);