(function($)
{
	var stateClasses = "sf-ui-scrollbar-focused sf-ui-scrollbar-blured";
	
	$.fn.isVisible = function()
    {
        var info = $(this).data("info");        
		return info.visible;
	};
    
	$.fn.sfScrollbar2 = function(options, param) 
	{
        //alert("sfScrollbar2: options=" + options + ", param=" + param);
        
		if (!($(this).data("sfui") == "Scrollbar2"))
        {
            //alert("sfScrollbar2: Initializing");
            
			$(this).data("sfui", "Scrollbar2");
			
			var contents ='<div class="scrollBar_barTop"></div><div class="scrollBar_barMiddle"><div class="scrollBar_barHandle"></div></div><div class="scrollBar_barBottom"></div>';
			$(this).html(contents);
		}
        
		if (typeof options == "object")
		{
            //alert("sfScrollbar2: Object");
            
			var info = new Object();
            var btnHeight = Number($("div.scrollBar_barTop", this).css("height").replace("px", "")) + 2; // for margins in css
            
			info.contentHeight = options.contentHeight;
			info.contentWrapperHeight = options.contentWrapperHeight;
            info.contentScrollAmount = options.contentScrollAmount;
            info.scrollerHeight = options.scrollerHeight - (2 * btnHeight);
            info.scrollerHandleHeight = Math.floor((info.contentWrapperHeight * info.scrollerHeight / info.contentHeight) - 2); // for borders in css
            info.scrollerScrollAmount = Math.floor(info.contentScrollAmount * info.scrollerHeight / info.contentHeight);
            
			if (info.contentHeight > info.contentWrapperHeight)
            {
                show(this);
                $("div.scrollBar_barMiddle", this).height(info.scrollerHeight);
                $("div.scrollBar_barHandle", this).height(info.scrollerHandleHeight).css("top", "0px");
                info.visible = true;
            }
            else
            {
                hide(this);
                info.visible = false;
            }
            
            //alert(btnHeight);
            //alert(info.contentHeight);
            //alert(info.contentWrapperHeight);
            //alert(info.contentScrollAmount);
            //alert(info.scrollerHeight);
            //alert(info.scrollerHandleHeight);
            //alert(info.scrollerScrollAmount);
            //alert(info.visible);
            
            $(this).data("info", info);
            
            blur(this);
		}
		else if (typeof options == "string") 
		{
			options = options.toLowerCase();
            
			switch (options)
            {
				case "show":
                    show(this);
                    break;
				
                case "hide":
                    hide(this);
                    break;
                    
                case "focus":
                    focus(this);
                    break;
                    
                case "blur":
                    blur(this);
                    break;
                    
				case "move":
                    move(this, param);
                    break;
                    
				default:
                    alert("Type error!");
                    break;
			}
		 }
		
	    return this;
	};

	function move(self, param)
	{
		var info = $(self).data("info");
        var top = 0;
        
        if (!info.visible)
        {
            return false;
        }
        
        if (param == "up")
        {
            top = Number($("div.scrollBar_barHandle", self).css("top").replace("px", "")) - info.scrollerScrollAmount;
            if (top < 1)
            {
                top = 1;
            }
        }
        else if (param == "down")
        {
            top = Number($("div.scrollBar_barHandle", self).css("top").replace("px", "")) + info.scrollerScrollAmount;
            if (top + info.scrollerHandleHeight > info.scrollerHeight)
            {
                top = info.scrollerHeight - info.scrollerHandleHeight - 1;
            }
        }
        
        $("div.scrollBar_barHandle", self).css("top", top+"px");
        
        return true;
	};
    
    function show(self)
    {
        $(self).show();
        return true;
    }
    
    function hide(self)
    {
        $(self).hide();
        return true;
    }
    
    function focus(self)
    {
        var info = $(self).data("info");
        
        if (!info.visible)
        {
            return false;
        }
        
        $(self).removeClass(stateClasses).addClass("sf-ui-scrollbar-focused");
    }
    
    function blur(self)
    {
        var info = $(self).data("info");
        
        if (!info.visible)
        {
            return false;
        }
        
        $(self).removeClass(stateClasses).addClass("sf-ui-scrollbar-blured");
    }
    
})(jQuery);
