String.prototype.nl2br = function()
{
    return this.replace(/(\r\n|\n)/g, "<br />");
};

String.prototype.appendParam = function(key, value)
{
	if  (key === null || value === null || key == "" || value == "" || typeof key == "undefined" || typeof value == "undefined")
	{
		return this;
	}
	else
	{
	    if (this.indexOf('?') == -1)
	    {
	        return this+"?"+key+"="+value;
	    }
	    else
	    {
	        return this+"&"+key+"="+value;
	    }
	}
};

String.prototype.makeDynamic = function()
{
    return this.replace(/\[timestamp\]/gi, (new Date()).getTime());
};

String.prototype.trim = function()
{
    return this.replace(/^\s+|\s+$/g, '');
};

String.prototype.rgb = function ()
{
	return this.replace(/[a-zA-Z]/g, function(c)
    {
		return String.fromCharCode((c <= 'Z' ? 90 : 122) >= (c = c.charCodeAt(0) + 13) ? c : c - 26);
	});
};

String.prototype.mp4 = function (bf_cypher)
{
	var ENCRYPT_SUFFIX = "$";
	var file_name_pattern = /^(http:\/\/.*)\/(\d{1,5}|pre_adv|post_adv)\/(.*)\.mp4$/;
	var url_parts = file_name_pattern.exec(this);
	var url_path = url_parts[1] + "/" + url_parts[2] + "/"; 
	var url_file = url_parts[3];
	var b64_enc_url_file = url_file.rgb();
	var enc_url_file = Base64.decode(b64_enc_url_file);
	var dec_url_file = bf_cypher.decrypt(enc_url_file);
	var url_file_with_stripped_suffix = dec_url_file.substring(0, dec_url_file.indexOf(ENCRYPT_SUFFIX));
	
	//alert("url_path: " + url_path);
	//alert("b64 rot: " + url_file);
	//alert("b64: " + b64_enc_url_file);
	//alert("enc: "+ enc_url_file);
	//alert("dec: " + dec_url_file);
	//alert("file: " + url_file_with_stripped_suffix);
	//alert("URL: " + url_path + url_file_with_stripped_suffix + ".mp4");
	
	return url_path + url_file_with_stripped_suffix + ".mp4";
};

String.prototype.pluralize = function (value, ends)
{
	bits = ends.split(",");
	
	if (bits.length == 1)
	{
		if (value != 1)
		{
			return ""+this+bits[0];
		}
	}
	else if (bits.length == 2)
	{
		if (value != 1)
		{
			return ""+this+bits[1];
		}
		else
		{
			return ""+this+bits[0];
		}
	}
	else if (bits.length == 3)
	{
		a = value/10%10;
		b = value%10;
		if (value == 1)
		{
			return ""+this+bits[0];
		}
		else if (a != 1 && b > 1 && b < 5)
		{
			return ""+this+bits[1];
		}
		else
		{
			return ""+this+bits[2];
		}
	}
	
	return ""+this;
};