(function($)
{
    var PlayerPlugin										= null;
    var AudioPlugin											= null;
    var TVMWPlugin											= null;
    var TVPlugin											= null;
    var NNaviPlugin											= null;
    var PluginAPI											= null;
    var objVideo2_controller								= null;
    var bf_cypher											= null;
    var lastMediaCallback									= null;
    var errorCallback										= null;
    var statsController										= null;
    var rightsController									= null;
    var movieSeenController									= null;
	var checkUserAccountDataCallback 						= null;
	var checkUserAccountDataCallbackInterval 				= null;
	var checkUserAccountDataCallbackIntervalMiliseconds 	= null;
	
	var media = [];
	var midrolls = {};
	var midrollsWatchDogs = [];
	var currentMediaIndex = 0;
	var startPlayingFromSecond = 0;
	var ageLimit = 0;
    
    //constant for size of screen
    var MAX_HEIGHT_SCREEN		= 540;
    var MAX_WIDTH_SCREEN		= 960;
    var JUMP_SECONDS			= 10;
    var jumpSecondsEvents		= 0;
    var jumpSecondsRun			= 0;
    var jumpOffset				= 0;
    var jumpSecondsTimer		= null;
    var jumpType;
    
    //constants for status of media    
    var PLAYING	= 1;
    var PAUSED	= 2;
    var STOPPED	= 3;
    var RESUME	= 4;
    
    //initial value for status
    var status 					= STOPPED;
    var statusBeforeJump		= null;
    var lastOnCurrentPlayTime	= null;
    var blockInfoScreen			= false;
    
    // total time of video
    var totalTime		= 0;
    var currentTime		= 0;
    
    var timeSecondHidden		= 5000;		// variable used to be hidden the progress bar after request to change for full screen
    var timeFullScreen			= 0;		// variable to get the value of time when the full screen is requested
    var boolMarkTime			= true;		// variable indicating if the time was marking when Full Screen called
    var boolBeginVideo			= false;	// variable used to prohibit to press key pause, play, stop, forward, backward before the Video begins
    
    var volumeSupported			= true;
    var volumeOSDSupported		= true;
    
    var scrollingButtonInterval = null;
    
	 $.fn.sfVideo2 = function(options, opt)
     {
		 if (!($(this).data("sfui") == "Video2"))
         {
            //alert("sfVideo2: Initializing");
            
			$(this).data("sfui", "Video2");
			$(this).html("<div id='Video2Div'></div>");
        }
        
        if (typeof options == "object")
        {
            if ((typeof options.movie != "undefined") && (typeof options.adverts != "undefined"))
            {
                setMedia(options.movie, options.adverts);
            }
            
            if (typeof options.jumpSeconds != "undefined")
            {
                JUMP_SECONDS = options.jumpSeconds;
            }
            
            if (typeof options.idVideo2_controller != "undefined")
            {
                objVideo2_controller = $("#"+ options.idVideo2_controller);
            }
            
            if (typeof options.lastMediaCallback != "undefined")
            {
                lastMediaCallback = options.lastMediaCallback;
            }
            
            if (typeof options.errorCallback != "undefined")
            {
                errorCallback = options.errorCallback;
            }
            
            if (typeof options.statsController != "undefined")
            {
                statsController = options.statsController;
            }
            
            if (typeof options.rightsController != "undefined")
            {
                rightsController = options.rightsController;
            }
            
            if (typeof options.movieSeenController != "undefined")
            {
                movieSeenController = options.movieSeenController;
            }
            
            if (typeof options.videoDecryptKey != "undefined")
            {
            	bf_cypher = new Blowfish(options.videoDecryptKey);
            }
            
            if (typeof options.checkUserAccountDataCallback != "undefined" && typeof options.checkUserAccountDataCallbackInterval != "undefined")
            {
            	checkUserAccountDataCallback = options.checkUserAccountDataCallback;
            	checkUserAccountDataCallbackIntervalMiliseconds = options.checkUserAccountDataCallbackInterval;
            }
            
            load();
        }
        else if (typeof options == "string")
        {
            switch (options)
            {
				case "stop":
                    runStop();
                    break;
                    
                case "pause":
                    runPause();
                    break;
                    
                case "resume":
                    runPlay();
                    break;
                    
                case "play":
                    if ((typeof opt != "undefined") && (typeof opt.movie != "undefined") && (typeof opt.adverts != "undefined"))
                    {
                    	setMedia(opt.movie, opt.adverts);
                    }
                    runPlay();
                    break;
                    
                case "backward":
                    runJumpBackward(JUMP_SECONDS);
                    break;
                    
                case "forward":
                    runJumpForward(JUMP_SECONDS);
                    break;
                    
                case "toogleMute":
                    toogleMute();
                    break;
                    
                case "RCKeyDefined":
                    objVideo2_controller.setVisible("visible");
                    boolMarkTime = true;
                    
                    switch (opt)
                    {
                        case $.sfKey.PLAY:
                            runPlay();
                            break;
                            
                         case $.sfKey.PAUSE:
                            if (boolBeginVideo)
                            {
                                runPause();
                            }
                            break;
                            
                         case $.sfKey.RW_:
                            if (boolBeginVideo)
                            {
                                if (TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
                                {
                                    runJumpBeginning();
                                }
                                else
                                {
                                    runJumpGeneric("backward");
                                }
                            }
                            break;
                            
                         case $.sfKey.RW:
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("backward");
                            }
                            break;
                        
                        case $.sfKey.FF_:
                            if (boolBeginVideo)
                            {
                                if (TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
                                {
                                    runJumpEnd();
                                }
                                else
                                {
                                    runJumpGeneric("forward");
                                }
                            }
                            break;
                        
                        case $.sfKey.FF:
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("forward");
                            }
                            break;
                            
                        case 1231: // AV 2011 rewind button pressed
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("backward");
                                scrollingButtonInterval = setInterval(function(){runJumpGeneric("backward");}, 300);
                            }
                            break;
                            
                        case 1230: // AV 2011 forward button pressed
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("forward");
                                scrollingButtonInterval = setInterval(function(){runJumpGeneric("forward");}, 300);
                            }
                            break;
                            
                        case 1232: // AV 2011 forward or rewind button released
                            clearInterval(scrollingButtonInterval);
                            break;
                            
                        case $.sfKey.STOP:
						case $.sfKey.RETURN:
                            runStop();
                            break;
						
						case $.sfKey.VOL_UP:
                            runVolumeUp();
							break;
                        
						case $.sfKey.VOL_DOWN:
                            runVolumeDown();
                            break;
                            
                        case $.sfKey.MUTE:
                            toogleMute();
                            break;
                            
                        case $.sfKey.INFO:
                            break;
                    }
                    break;
                    
                case "getTotalTime":
                    return PlayerPlugin.GetDuration();
                    
                case "getStatus":
                    return status;
                    
                case "show":
                    //alert("sfVideo2: Showing player");
                    $(this).show();
                    break;
                    
                case "hide":
                    //alert("sfVideo2: Hidding player");
                    $(this).hide();
                    break;
			}
        }
        
	    return this;
	};
	
	function midrollWatchDog (param_watch_time, param_midrolls)
	{
		var checkPlayerStatusInterval = 5000;
		var interval = null;
		var counter = 0;
		var watch_time = parseInt(param_watch_time) * 1000 * 60;
		var midrolls = param_midrolls;
		
		var switchMediaToMidrolls = function ()
		{
			//alert("Switching to media midrolls");
			media = midrolls;
	    	currentMediaIndex = 0;
		};
		
		var stopPlayer = function ()
		{
			//alert("Stopping player");
			
	        PlayerPlugin.Stop();
	        status = STOPPED;
	        objVideo2_controller.changeButton("stop", isMediaMovie());
	        startPlayingFromSecond = parseInt((currentTime > 5000 ? currentTime - 5000 : 0) / 1000);
	        currentTime = 0;
	        totalTime = 0;
		};
		
		var checkPlayerStatus = function ()
		{
			//alert("Checking player status: "+counter+" "+ watch_time);
			
			if (isMediaMovie() && (status == PLAYING))
			{
				counter += checkPlayerStatusInterval;
				
				if (counter >= watch_time)
				{
					releaseWatchDog();
					stopPlayer();
					switchMediaToMidrolls();
					runPlay();
				}
			}
			
			return true;
		};
		
		var initWatchDog = function ()
		{
			//alert("Setting midroll watchdog");
			
			interval = setInterval(checkPlayerStatus, checkPlayerStatusInterval);
		};
		
		var releaseWatchDog = function ()
		{
			//alert("Releasing midroll watchdog");
			
		    if (interval)
		    {
		        clearInterval(interval);
		        interval = null;
		        counter = 0;
		    }
		};
		
		this.release = releaseWatchDog;
		this.init = initWatchDog;
	}
	
	function initMidrolls()
	{
		$.each(midrolls, function(i, v)
		{
			if (v.length > 0)
			{
				var temp = new midrollWatchDog(i, v);
				temp.init();
				midrollsWatchDogs.push(temp);
			}
		});
	}
	
    function isAV2010()
    {
        return (NNaviPlugin.GetModelCode().substr(0, 4) == "BD-C");
    }
    
    function updateVolumeButtons()
    {
        //alert("sfVideo2: updateVolumeButtons");
        
        if (volumeOSDSupported)
        {
            objVideo2_controller.setVolumeControlsVisible(true);
            
            objVideo2_controller.setVolume(AudioPlugin.GetVolume());
            
            var isMute = AudioPlugin.GetUserMute();
            
            if (isMute == $.sf.define.PLR_TRUE)
            {
                objVideo2_controller.setMute("mute");
            } 
            else if (isMute == $.sf.define.PLR_FALSE)
            {
                objVideo2_controller.setMute("unmute");
            }
            else
            {
                 alert("sfVideo2: updateVolumeButtons error");
            }
        }
        else
        {
            objVideo2_controller.setVolumeControlsVisible(false);
        }
    }
    
    /*
    * mute - $.sf.define.PLR_TRUE
    * unmute - $.sf.define.PLR_FALSE
    */
    function setMute(mute)
    {
        //alert("sfVideo2: setMute, mute="+mute);
        
        if (typeof mute == "undefined")
        {
            return false;
        }
        
        if (volumeSupported)
        {
            if (mute == $.sf.define.PLR_TRUE)
            {
                AudioPlugin.SetUserMute($.sf.define.PLR_TRUE);
            }
            else if (mute == $.sf.define.PLR_FALSE)
            {
                AudioPlugin.SetUserMute($.sf.define.PLR_FALSE);
            }
            else
            {
                 alert("sfVideo2: setMute error");
            }
        }
        
        updateVolumeButtons();
    }
    
    function toogleMute()
    {
        //alert("sfVideo2: toogleMute");
        
        var isMute = AudioPlugin.GetUserMute();
        
        if (isMute == $.sf.define.PLR_TRUE)
        {
            setMute($.sf.define.PLR_FALSE);
        } 
        else if (isMute == $.sf.define.PLR_FALSE)
        {
            setMute($.sf.define.PLR_TRUE);
        }
        else
        {
             alert("sfVideo2: toogleMute error");
        }
    }
    
	function runVolumeUp()
	{
		//alert("sfVideo2: Volume Up");
	
		if (volumeSupported)
		{
			AudioPlugin.SetVolumeWithKey($.sf.define.PL_AUDIO_VOLUME_KEY_UP);
		}
		
		updateVolumeButtons();
	}
    
    function runVolumeDown()
    {
        //alert("sfVideo2: Volume Down");

        if (volumeSupported)
        {
            AudioPlugin.SetVolumeWithKey($.sf.define.PL_AUDIO_VOLUME_KEY_DOWN);
        }

        updateVolumeButtons();
    }
        
    function setVolumeStrategy()
    {
        // check volume strategy
        var outputDevice = AudioPlugin.GetOutputDevice();

        if(outputDevice == $.sf.define.PL_AUDIO_OUTPUT_DEVICE_EXTERNAL || TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
        {
            // no volume support and no osd support
            volumeSupported = false;
            volumeOSDSupported = false;
        }
        else
        {
           if(outputDevice == $.sf.define.PL_AUDIO_OUTPUT_DEVICE_RECEIVER)
           {
                // volume support but no osd support
                volumeSupported = true;
                volumeOSDSupported = false;
           }
           else
           {
                // volume support and osd support
                volumeSupported = true;
                volumeOSDSupported = true;
           }
        }
    }
    
    function runStop()
    {
        //alert("sfVideo2: Stopping");
    	
		try
		{
			PlayerPlugin.Stop();
			PlayerPlugin.ClearScreen();
		}
		catch (e)
		{
			alert(e);
		}
		
        status = STOPPED;
        statusBeforeJump = null;
        lastOnCurrentPlayTime = null;
        blockInfoScreen = false;
        objVideo2_controller.changeButton("stop", isMediaMovie());
        totalTime = 0;
        currentTime = 0;
        startPlayingFromSecond = 0;
        boolBeginVideo = false;
        timeFullScreen = 0;
        boolMarkTime = true;
        PluginAPI.setOnScreenSaver();
        setMedia();
        statsController.moviesStats.abortHit();
        clearInterval(checkUserAccountDataCallbackInterval);
        ageLimit = 0;
        displayAgeLimitSymbol(0);
    }
    
    function setMedia(movie, adverts)
    {
        //alert("sfVideo2: Setting media");
        
    	media = [];
    	midrolls = {};
    	currentMediaIndex = 0;
    	startPlayingFromSecond = 0;
    	$.each(midrollsWatchDogs, function(i, v)
    	{
    		v.release();
    	});
    	midrollsWatchDogs = [];
    	
        if ((typeof movie == "undefined") || (typeof adverts == "undefined"))
        {
            return false;
        }
        
        ageLimit = movie.age_limit;
        
        if (typeof adverts["0"] != "undefined")
        {
        	if (adverts["0"].length > 0)
        	{
        		media = adverts["0"];
        	}
        	
        	delete adverts["0"];
        }
        
        movie.type = "movie";
        movie.tracking_code_tv = "";
        movie.report_usage = true;
        media.push(movie);
        
        movie_for_midroll = $.extend({}, movie);
        movie_for_midroll.report_usage = false;
        midrolls = adverts;
        $.each(midrolls, function(i, v)
        {
        	if (v.length > 0)
        	{
        		midrolls[i].push(movie_for_midroll);
        	}
        });
        
        initMidrolls();
        
        return true;
    }
    
    function isMediaMovie()
    {
    	var currentVideo = media[currentMediaIndex];
    	
    	if (typeof currentVideo === "undefined")
    	{
    		alert("isMediaMovie Error: No media.");
    		return false;
    	}
    	
    	return (currentVideo.type == "movie");
    }
    
    function runPlay(seconds)
    {
        //alert("sfVideo2: Playing");
        
        var ret = false;
        
        if (typeof seconds === "undefined")
        {
        	seconds = 0;
        }
        
        blockInfoScreen = false;
        
        if (status != STOPPED)
        {
            status = RESUME;
            ret = PlayerPlugin.Resume();
            objVideo2_controller.changeButton("play", isMediaMovie());
        }
        else
        {
            status = PLAYING;
            
            PluginAPI.setOffScreenSaver();
            
            setVolumeStrategy();
            updateVolumeButtons();
            
            var mediaNativeWidth = media[currentMediaIndex].width;
            var mediaNativeHeight = media[currentMediaIndex].height;
            
            var scaledHeight = Math.floor(MAX_WIDTH_SCREEN * mediaNativeHeight / mediaNativeWidth);
            var scaledWidth = 0;
            
            if (scaledHeight > MAX_HEIGHT_SCREEN)
            {
                scaledWidth = Math.floor(MAX_HEIGHT_SCREEN * mediaNativeWidth / mediaNativeHeight);
                scaledHeight = MAX_HEIGHT_SCREEN;
            }
            else
            {
                scaledWidth = MAX_WIDTH_SCREEN;
            }
            
            var scaledLeft = Math.floor((MAX_WIDTH_SCREEN - scaledWidth) / 2);
            var scaledTop = Math.floor((MAX_HEIGHT_SCREEN - scaledHeight) / 2);
            
            //alert(mediaNativeWidth);
            //alert(mediaNativeHeight);
            //alert(scaledWidth);
            //alert(scaledHeight);
            //alert(scaledLeft);
            //alert(scaledTop);
            
            //alert("sfVideo2: Trying to play "+media[currentMediaIndex].url.mp4(bf_cypher)+" from "+seconds+" second");
            
            PlayerPlugin.SetDisplayArea(scaledLeft, scaledTop, scaledWidth, scaledHeight);
			if (typeof PlayerPlugin.OnStreamInfoReady === "undefined")
			{
				PlayerPlugin.OnCurrentPlayTime = "OnCurrentPlayTime";
				PlayerPlugin.OnBufferingComplete = "OnBufferingComplete";
				PlayerPlugin.OnBufferingProgress = "OnBufferingProgress";
				PlayerPlugin.OnBufferingStart = "OnBufferingStart";
				PlayerPlugin.OnConnectionFailed = "OnConnectionFailed";
				PlayerPlugin.OnNetworkDisconnected = "OnNetworkDisconnected";
				PlayerPlugin.OnRenderError = "OnRenderError";
				PlayerPlugin.OnRenderingComplete = "OnRenderingComplete";
				PlayerPlugin.OnStreamInfoReady = "OnStreamInfoReady";
				PlayerPlugin.OnStreamNotFound = "OnStreamNotFound";
			}
			
			if(media[currentMediaIndex])
			{
				if (seconds)
				{
					//ret = PlayerPlugin.ResumePlay(media[currentMediaIndex].url.mp4(bf_cypher), seconds);
					
					PlayerPlugin.InitPlayer(media[currentMediaIndex].url.mp4(bf_cypher));
					PlayerPlugin.SetPlayerProperty(7, 0, 0);
					PlayerPlugin.StartPlayback(seconds);
				}
				else
				{
					//ret = PlayerPlugin.Play(media[currentMediaIndex].url.mp4(bf_cypher));
					
					//PlayerPlugin.InitPlayer(media[currentMediaIndex].url.mp4(bf_cypher));
					//PlayerPlugin.SetPlayerProperty(7, 0, 0);
					//ret = PlayerPlugin.StartPlayback();
					
					PlayerPlugin.InitPlayer(media[currentMediaIndex].url.mp4(bf_cypher));
					PlayerPlugin.SetPlayerProperty(7, 0, 0);
					PlayerPlugin.StartPlayback(0); 
				}
			}
            
            objVideo2_controller.setBuffering(0);
            objVideo2_controller.setVisible("visible");
        }
        
        //alert("sfVideo2: Playing returns="+ret);
        
        return ret;
    }
    
    function runPause()
    {
        //alert("sfVideo2: Pausing");

        var ret = false;
        
        blockInfoScreen = false;
        
        if (status != PAUSED)
        {
			if (PlayerPlugin.Pause())
			{
				ret = true;
				status = PAUSED;
				objVideo2_controller.changeButton("pause", isMediaMovie());			
			}
        }
        
        return ret;
    }
    
    function runJumpGeneric(type)
    {
        function getJumpSecondsMultiplier(jumpSecondsEvents)
        {
            if (jumpSecondsEvents < 6)
            {
                return 1;
            }
            else if (jumpSecondsEvents < 18)
            {
                return 3;
            }
            else if (jumpSecondsEvents < 24)
            {
                return 6;
            }
            else if (jumpSecondsEvents < 30)
            {
                return 12;
            }
            else 
            {
                return 30;
            }
        }
        
        if (!isMediaMovie())
        {
            return false;
        }
        
        clearTimeout(jumpSecondsTimer);
        
        blockInfoScreen = true;
        
        if (!statusBeforeJump)
        {
            statusBeforeJump = status;
        }
        
        if (jumpType != type)
        {
            jumpOffset += jumpSecondsRun;
            jumpType = type;
            jumpSecondsEvents = 0;
            jumpSecondsRun = 0;
        }
        
        if (status != PAUSED)
        {
            PlayerPlugin.Pause();
            status = PAUSED;
        }
        
        objVideo2_controller.changeButton(type, isMediaMovie());
        
        if (type == "forward")
        {
			jumpSecondsRun = jumpSecondsRun + (getJumpSecondsMultiplier(jumpSecondsEvents) * JUMP_SECONDS * 1000);
			var jumpToTime = currentTime + jumpOffset + jumpSecondsRun;			
			
            if (jumpToTime < totalTime - 5000)
            {
                jumpSecondsEvents++;
                
                objVideo2_controller.setTime( formatTime(jumpToTime) + "/" + formatTime(totalTime) );
                objVideo2_controller.setProgress((100 * (jumpToTime)) / totalTime);
            }
            else
            {
                jumpSecondsRun = totalTime - currentTime - 15000;
                runJumpForward(parseInt(jumpSecondsRun / 1000));
                
                objVideo2_controller.setTime( formatTime(totalTime - 15000) + "/" + formatTime(totalTime) );
                objVideo2_controller.setProgress((100 * (totalTime - 15000)) / totalTime);
                
                jumpSecondsEvents = 0;
                jumpSecondsRun = 0;
                jumpType = null;
                jumpOffset = 0;
                
                blockInfoScreen = false;
                
                // block forward / rewind until video is buffered and playing
                boolBeginVideo = false;
                
                if (statusBeforeJump != PAUSED || isAV2010())
                {                    
                    runPlay();
                }
                
                statusBeforeJump = null;
                
                return true;
            }
        }
        else if (type == "backward")
        {
			jumpSecondsRun = jumpSecondsRun - (getJumpSecondsMultiplier(jumpSecondsEvents) * JUMP_SECONDS * 1000);
			var jumpToTime = currentTime + jumpOffset + jumpSecondsRun;
			
            if (jumpToTime > 0)
            {
                jumpSecondsEvents++;
                
                objVideo2_controller.setTime( formatTime(jumpToTime) + "/" + formatTime(totalTime) );
                objVideo2_controller.setProgress((100 * (jumpToTime)) / totalTime);
            }
            else
            {
                jumpSecondsRun = currentTime;
                runJumpBackward(parseInt(jumpSecondsRun / 1000));
                
                objVideo2_controller.setTime( formatTime(0) + "/" + formatTime(totalTime) );
                objVideo2_controller.setProgress(0);
                
                jumpSecondsEvents = 0;
                jumpSecondsRun = 0;
                jumpType = null;
                jumpOffset = 0;
                
                blockInfoScreen = false;
                
                // block forward / rewind until video is buffered and playing
                boolBeginVideo = false;
                
                if (statusBeforeJump != PAUSED || isAV2010())
                {                    
                    runPlay();
                }
                
                statusBeforeJump = null;
                
                return true;
            }
        }
        
        jumpSecondsTimer = setTimeout(function()
        {
            if (jumpOffset + jumpSecondsRun > 0)
            {
                runJumpForward(parseInt((jumpOffset + jumpSecondsRun) / 1000));
            }
            else
            {
                runJumpBackward(parseInt(Math.abs(jumpOffset + jumpSecondsRun) / 1000));
            }
            
            jumpSecondsEvents = 0;
            jumpSecondsRun = 0;
            jumpType =  null;
            jumpOffset = 0;
            
            blockInfoScreen = false;
            
            if (statusBeforeJump != PAUSED || isAV2010())
            {
                // block forward / rewind until video is buffered and playing
                boolBeginVideo = false;
                
                runPlay();
            }
            
            statusBeforeJump = null;
            
        }, 1500);
        
        return true;
     }
    
     function runJumpBackward(seconds)
     {
        //alert("sfVideo2: Rewind ("+seconds+")");
        
        if (isMediaMovie())
        {
            objVideo2_controller.changeButton("backward", isMediaMovie());
            PlayerPlugin.JumpBackward(seconds);
        }
     }
    
     function runJumpForward(seconds)
     {
        //alert("sfVideo2: Forward ("+seconds+")");
        
        if (isMediaMovie())
        {
            objVideo2_controller.changeButton("forward", isMediaMovie());
            PlayerPlugin.JumpForward(seconds);
        }
     }
    
     function runJumpBeginning()
     {
        //alert("sfVideo2: Beginning");
        
        if (isMediaMovie())
        {
            blockInfoScreen = true;
            boolBeginVideo = false;
            
            objVideo2_controller.changeButton("backward", isMediaMovie());
            objVideo2_controller.setTime( formatTime(0) + "/" + formatTime(totalTime) );
            objVideo2_controller.setProgress(0);
            
            PlayerPlugin.JumpBackward(parseInt(currentTime / 1000));
            
            setTimeout(function()
            {
                blockInfoScreen = false;
            
                if (isAV2010())
                {    
                    runPlay();
                }
            }, 1000);
        }
     }
    
     function runJumpEnd()
     {
        //alert("sfVideo2: End");
        
        if (isMediaMovie() &&  (totalTime - currentTime > 15000))
        {
            blockInfoScreen = true;
            boolBeginVideo = false;
            
            objVideo2_controller.changeButton("forward", isMediaMovie());
            objVideo2_controller.setTime( formatTime(totalTime - currentTime - 15000) + "/" + formatTime(totalTime) );
            objVideo2_controller.setProgress(100);
            
            PlayerPlugin.JumpForward(parseInt((totalTime - currentTime - 15000) / 1000));
            
            setTimeout(function()
            {
                blockInfoScreen = false;
            
                if (isAV2010())
                {
                    runPlay();
                }
            }, 1000);
        }
     }
    
    function load()
    {
        //alert("sfVideo2: Loading");
        
        tagObject = "";
        tagObject += "<object id='pluginObjectPlayer' style='display:block;z-index:99999;' classid='clsid:SAMSUNG-INFOLINK-PLAYER' class='videoConfiguration'></object>"; // for player support
        tagObject += "<object id='pluginObjectAudio' classid='clsid:SAMSUNG-INFOLINK-AUDIO' style='display:block;width:0px;height:0px;'></object>"; // for audio support
        tagObject += "<object id='pluginObjectNNavi' classid='clsid:SAMSUNG-INFOLINK-NNAVI' style='display:block;width:0px;height:0px;'></object>"; // for screen saver support, and product code
        tagObject += "<object id='pluginObjectTV' classid='clsid:SAMSUNG-INFOLINK-TV' style='display:block;width:0px;height:0px;'></object>"; // for product type
        
		try
		{
			$("#Video2Div").empty();
		}
		catch(e){alert("psps err="+e.message);}
		
        document.getElementById("Video2Div").innerHTML = tagObject ;
        
        PlayerPlugin = document.getElementById("pluginObjectPlayer");
        AudioPlugin = document.getElementById("pluginObjectAudio");
        NNaviPlugin = document.getElementById("pluginObjectNNavi");
        TVMWPlugin = document.getElementById("pluginObjectTVMW"); // declared in index.html, needed also for blocking SOURCE KEY
        TVPlugin =  document.getElementById("pluginObjectTV");
        
        //this.OriginalSource = TVMWPlugin.GetSource();
        //TVMWPlugin.SetMediaSource();
        
        //PlayerPlugin.SetTotalBufferSize(5120*1024);
        //PlayerPlugin.SetInitialBuffer(1024*1024);
        //PlayerPlugin.SetInitialTimeOut(15);
        //PlayerPlugin.SetPendingBuffer(512*1024);
        
        PlayerPlugin.ClearScreen();
        
		$("#pluginObjectPlayer").width(MAX_WIDTH_SCREEN);
        $("#pluginObjectPlayer").height(MAX_HEIGHT_SCREEN);
		
        PlayerPlugin.SetDisplayArea(0, 0, MAX_WIDTH_SCREEN, MAX_HEIGHT_SCREEN);
        
        // attach events
        PlayerPlugin.OnCurrentPlayTime = "OnCurrentPlayTime";
        PlayerPlugin.OnBufferingComplete = "OnBufferingComplete";
        PlayerPlugin.OnBufferingProgress = "OnBufferingProgress";
        PlayerPlugin.OnBufferingStart = "OnBufferingStart";
        PlayerPlugin.OnConnectionFailed = "OnConnectionFailed";
        PlayerPlugin.OnNetworkDisconnected = "OnNetworkDisconnected";
        PlayerPlugin.OnRenderError = "OnRenderError";
        PlayerPlugin.OnRenderingComplete = "OnRenderingComplete";
        PlayerPlugin.OnStreamInfoReady = "OnStreamInfoReady";
        PlayerPlugin.OnStreamNotFound = "OnStreamNotFound";
        
        // for screen saver
        PluginAPI = new Common.API.Plugin();
        
        setVolumeStrategy();
        updateVolumeButtons();
    }
    
    function formatTime(seconds)
    {
        if(!isNaN(seconds) && seconds > 0)
        {
            seconds /= 1000;
            hours = Math.floor(seconds / 3600);
            seconds %= 3600;
            minutes = Math.floor(seconds / 60);
            seconds %= 60;
            seconds = parseInt(seconds);
            (hours < 10) ? hps = "0" : hps = "";
            (minutes < 10) ? mps = "0" : mps = "";
            (seconds < 10) ? sps = "0" : sps = "";

            return hps+hours+":"+mps+minutes+":"+sps+seconds;
        }
        else
        {
            return "00:00:00";
        }
    }
    
    function displayAgeLimitSymbol(ageLimit)
    {
    	$("#ageLimit .ageLimit").hide();
    	
    	if (ageLimit >= 18)
    	{
    		$("#ageLimit .ageLimit18").show();
    	}
    	else if (ageLimit >= 16)
    	{
    		$("#ageLimit .ageLimit16").show();
    	}
    	else if (ageLimit >= 12)
    	{
    		$("#ageLimit .ageLimit12").show();
    	}
    }
    
    OnCurrentPlayTime = function(time)
    {
        //alert("sfVideo2: OnCurrentPlayTime, time="+time);
        
        currentTime = parseInt(time);
        
        if ( lastOnCurrentPlayTime == currentTime )
        {
            return true;
        }
        else
        {
            lastOnCurrentPlayTime = currentTime;
            
            if ( blockInfoScreen )
            {
                return true;
            }
        }
        
        if ( status == PLAYING || status == RESUME || status == PAUSED )
        {
            if ( status != PAUSED )
            {
                status = PLAYING;
                objVideo2_controller.changeButton("play", isMediaMovie());
            }
            else if ( status == PAUSED )
            {
                objVideo2_controller.changeButton("pause", isMediaMovie());
            }
            
            objVideo2_controller.setProgress((100 * currentTime) / totalTime);
            
            if (currentTime <= totalTime)
            {
                objVideo2_controller.setTime( formatTime(currentTime) + "/" + formatTime(totalTime) );
            }
            else
            {
                objVideo2_controller.setTime( formatTime(totalTime) + "/" + formatTime(totalTime) );
            }
            
            boolBeginVideo = true;
        }
        else if ( status == STOPPED )
        {
            boolBeginVideo = false;
            objVideo2_controller.changeButton("stop", isMediaMovie());
        }
        
        if (boolMarkTime)
        {
            timeFullScreen = currentTime;
            boolMarkTime = false;
        } 
        
        if (boolMarkTime == false)
        {
            if ( currentTime >= (timeSecondHidden + timeFullScreen) )
            {
                objVideo2_controller.setVisible("hidden");
            }
        }
    };
    
    OnStreamInfoReady = function()
    {
        //alert("sfVideo2: OnStreamInfoReady");
        
        totalTime = parseInt(PlayerPlugin.GetDuration());
        objVideo2_controller.setTime( formatTime(0) + "/" + formatTime(totalTime) );
        
        var currentVideo = media[currentMediaIndex];
        var lastVideo = media[media.length-1];
        
        if (currentVideo.type == "movie")
        {
        	displayAgeLimitSymbol(ageLimit);
        }
        else
        {
        	displayAgeLimitSymbol(0);
        }
            
        if (typeof statsController != "undefined")
        {
            if (currentVideo.type == "advert" && currentVideo.id != null && lastVideo.type == "movie" && lastVideo.id != null)
            {
                statsController.advertsStats.sendHit(false, "AID", currentVideo.id, "ATITLE", currentVideo.title, "MID", lastVideo.id, "MTITLE", lastVideo.title);
                statsController.trackingCode.sendHit(currentVideo.tracking_code_tv);
            }
            else if (currentVideo.type == "movie" && currentVideo.id != null && currentVideo.report_usage && currentVideo.license == "PAID")
            {
            	statsController.moviesStats.sendHit(true, "MID", currentVideo.id, "MTITLE", currentVideo.title);
            }
            else if (currentVideo.type == "movie" && currentVideo.id != null && currentVideo.report_usage)
            {
            	statsController.moviesStats.sendHit(false, "MID", currentVideo.id, "MTITLE", currentVideo.title);
            }
        }
        
        if (typeof rightsController != "undefined")
        {
            if (currentVideo.type == "advert" && currentVideo.id != null)
            {
                rightsController.sendHit(currentVideo.id, "video_start");
            }
        }
        
        if (typeof movieSeenController != "undefined")
        {
            if (currentVideo.type == "movie" && currentVideo.id != null && currentVideo.report_usage)
            {
                movieSeenController.sendHit(currentVideo.id);
            }
        }
        
        if (typeof checkUserAccountDataCallback != "undefined" && currentVideo.type == "movie")
        {
        	clearInterval(checkUserAccountDataCallbackInterval);
            checkUserAccountDataCallbackInterval = setInterval(function ()
            {
            	checkUserAccountDataCallback(currentVideo.license);
            	
            }, checkUserAccountDataCallbackIntervalMiliseconds);
        }
    };
    
    OnBufferingStart = function()
    {
        //alert("sfVideo2: OnBufferingStart");
        
        boolMarkTime = true;
        objVideo2_controller.setVisible("visible");
        objVideo2_controller.setBuffering(0);
    };
    
    OnBufferingProgress = function(percent)
    {
        //alert("sfVideo2: OnBufferingProgress, percent=" + percent);
        
        objVideo2_controller.setBuffering(percent);
    };
    
    OnBufferingComplete = function()
    {
        //alert("sfVideo2: OnBufferingComplete");
        
        boolMarkTime = true;
        objVideo2_controller.setBuffering(100);
    };
    
    OnRenderingComplete = function()
    {
        //alert("sfVideo2: OnRenderingComplete");
        
        PlayerPlugin.Stop();
        status = STOPPED;
        objVideo2_controller.changeButton("stop", isMediaMovie());
        currentTime = 0;
        totalTime = 0;
        
        if (typeof rightsController != "undefined")
        {
            var currentVideo = media[currentMediaIndex];
            
            if (currentVideo.type == "advert" && currentVideo.id != null)
            {
                rightsController.sendHit(currentVideo.id, "video_end");
            }
        }
        
        if (currentMediaIndex < media.length - 1)
        {
            //alert("sfVideo2: Next media available");
            
            currentMediaIndex++;
            if (isMediaMovie())
            {
                runPlay(startPlayingFromSecond);
                startPlayingFromSecond = 0;            	
            }
            else
            {
                runPlay();
            }
        }
        else
        {
            //alert("sfVideo2: Last media");
            
            runStop();
            if (typeof lastMediaCallback != "undefined")
            {
                lastMediaCallback();
            }
        }
    };
    
    OnConnectionFailed = function()
    {
        //alert("sfVideo2: OnConnectionFailed");
    	
        var vid = (media[currentMediaIndex].type == "movie" ? "M" : "A") + media[currentMediaIndex].id;
        
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(1, vid, "Nie udało się nawiązać połączenia z serwerem."); // Failed to connect to streaming server.
        }
    };
    
    OnNetworkDisconnected = function()
    {
        //alert("sfVideo2: OnNetworkDisconnected");
        
    	var vid = (media[currentMediaIndex].type == "movie" ? "M" : "A") + media[currentMediaIndex].id;
    	
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(2, vid, "Brak połączenia z siecią."); // Usually this event means network is disconnected during the streaming.
        }
    };
    
    OnStreamNotFound = function()
    {
        //alert("sfVideo2: OnStreamNotFound");
    	
    	var vid = (media[currentMediaIndex].type == "movie" ? "M" : "A") + media[currentMediaIndex].id;
    	
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(3, vid, "Nie znaleziono materiału wideo."); // Streaming server replys that the stream specified by url parameter of Play() API does not exist.
        }
    };
    
    OnRenderError = function(renderErrorType)
    {
        //alert("sfVideo2: OnRenderError, renderErrorType="+renderErrorType);
        
    	var vid = (media[currentMediaIndex].type == "movie" ? "M" : "A") + media[currentMediaIndex].id;
    	
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            try
            {
                renderErrorType = parseInt(renderErrorType, 10);
            }
            catch(e)
            {
                errorCallback(9, vid, "Nieznany błąd."); // Unknown error
                return;
            }
            
            switch (renderErrorType)
            {
                case 1:
                    errorCallback(4, vid, "Niewspierany kontener."); // 1 : Unsupported container
                    break;
                    
                case 2:
                    errorCallback(5, vid, "Niewspierany kodek wideo."); // 2 : Unsupported video codec
                    break;
                    
                case 3:
                    errorCallback(6, vid, "Niewspierany kodek audio."); // 3 : Unsupported audio codec
                    break;
                    
                case 4:
                    errorCallback(7, vid, "Niewspierana rozdzielczość wideo."); // 4 : Unsupported video resolution
                    break;
                
                default:
                    errorCallback(8, vid, "Nieznany błąd."); // Unknown error
                    break;
            }
        }
    };
    
})(jQuery);